# -*- coding: iso-8859-1 -*-
"""
/***************************************************************************
Name                  :EasyCustomLabeling
Description          : essais de premier plugin regis
Date                 : 04/01/2012 
copyright            : (C) 2012 by regis haubourg
version              : 0.4  ! requires Memory Layer Saver 1.0 to handle "project qgs save" because of gml save new behaviour in qgis 1.8 - gdal 1.9
email                : regis dot haubourg at eau-adour-garonne.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

"""
# Import the PyQt and QGIS libraries
from PyQt4 import QtGui
from PyQt4.QtCore import * 
from PyQt4.QtGui import *
from qgis.core import *
from qgis.utils import *   
from PyQt4 import QtXml

# Initialize Qt resources from file resources.py
import resources
import os.path
# load translation libraries

    
class EasyCustomLabeling: 

  def __init__(self, iface):
    # Save reference to the QGIS interface
    self.iface = iface

  def initGui(self):  
 
    # internationalization
    locale = QSettings().value("locale/userLocale").toString()
    myLocale = locale[0:2]
    localeDictionary = QFileInfo(os.path.realpath(__file__)).path()+"/i18n/EasyCustomLabeling_" + myLocale + ".qm"
    # translator init
    if QFileInfo(localeDictionary).exists():
        self.translator = QTranslator()
        self.translator.load(localeDictionary)
        if qVersion() > '4.3.3':
            QCoreApplication.installTranslator(self.translator)
            
    # Create action that will start plugin configuration
    self.action = QAction( QIcon( ":/plugins/EasyCustomLabeling/icon.png" ), QtGui.QApplication.translate("EasyCustomLabeling", "Generates centroid layer ready for custom labeling tools", None, QtGui.QApplication.UnicodeUTF8), self.iface.mainWindow() )
    # connect the action to the run method
    QObject.connect(self.action, SIGNAL("activated()"), self.run) 

    self.actionArrow = QAction(QIcon(os.path.join( os.path.dirname(__file__), "arrow.png" )), QtGui.QApplication.translate("EasyCustomLabeling", "Generates lines from objects to labels", None, QtGui.QApplication.UnicodeUTF8), self.iface.mainWindow())
    self.actionAbout = QAction(QIcon(os.path.join( os.path.dirname(__file__), "icon.png" )), QtGui.QApplication.translate("EasyCustomLabeling", "About easy labeling plugin", None, QtGui.QApplication.UnicodeUTF8), self.iface.mainWindow())

    # connect the action to the run method
    QObject.connect(self.actionArrow, SIGNAL("activated()"), self.runArrow) 
    QObject.connect(self.actionAbout, SIGNAL("activated()"), self.runAbout) 

    
   #adds buttons to labeling toolbar if exists
    self.toolBar = self.iface.pluginToolBar()
    toolbars = self.iface.mainWindow().findChildren(QToolBar)
    toolbarFound = False
    for toolbar in toolbars: # checks all existing toolbars 
        #QMessageBox.warning( None, "DEBUG", toolbar.objectName())
        if toolbar.objectName() == "mLabelToolBar":
            #QMessageBox.warning( None, "DEBUG", "LabelToolBar Found")
            self.toolBar = toolbar  
            global actions #saves mLabelToolbar for unload 
            actions = self.toolBar.actions() # list with mLabelToolBar actions
             #  append easy labeling actions to list
            actions_easylabel = actions
            actions_easylabel.append(self.action)
            actions_easylabel.append(self.actionArrow)
            
            self.toolBar.clear() #clear all actions of toolbar
            #QMessageBox.warning( None, "DEBUG", str(actions_easylabel))
            i=0
            for a in actions:
                self.toolBar.addAction(actions_easylabel[i])
                i=i+1
                   
            toolbarFound = True
           
    if not toolbarFound : 
        QMessageBox.warning( None, "DEBUG", "labeling toolbar not found. Please use menu Extension/Easy Custom Labeling")        
    
    # else TODO for QGIS <= 1.6
        #adds in extension toolbar



    self.iface.addPluginToMenu( "&" + QtGui.QApplication.translate("EasyCustomLabeling", "Easy Custom labeling", None, QtGui.QApplication.UnicodeUTF8), self.action)
    self.iface.addPluginToMenu( "&" + QtGui.QApplication.translate("EasyCustomLabeling", "Easy Custom labeling", None, QtGui.QApplication.UnicodeUTF8), self.actionArrow)
    self.iface.addPluginToMenu( "&" + QtGui.QApplication.translate("EasyCustomLabeling", "Easy Custom labeling", None, QtGui.QApplication.UnicodeUTF8), self.actionAbout)
    
  
    
  def unload( self):
    # Remove the plugin menu item and icon
    self.toolBar.removeAction( self.action)
    self.toolBar.removeAction( self.actionArrow)
    
    self.iface.removePluginMenu( "&" + QtGui.QApplication.translate("EasyCustomLabeling", "Easy Custom labeling", None, QtGui.QApplication.UnicodeUTF8), self.action)
    self.iface.removePluginMenu( "&" + QtGui.QApplication.translate("EasyCustomLabeling", "Easy Custom labeling", None, QtGui.QApplication.UnicodeUTF8), self.actionArrow)
    self.iface.removePluginMenu( "&" + QtGui.QApplication.translate("EasyCustomLabeling", "Easy Custom labeling", None, QtGui.QApplication.UnicodeUTF8), self.actionAbout)

    
    #remove action from mLabelToolBar if exists
    toolbars = self.iface.mainWindow().findChildren(QToolBar)
    for toolbar in toolbars:
       
        if toolbar.objectName() == "mLabelToolBar":
            self.toolBar = toolbar
            
            # You have to save all of the actions from the toolbar
            actions = self.toolBar.actions()
            # then, you clear the complete toolbar
            self.toolBar.clear()

            # and you re-add only the actions yo uwant
            i=0
            for a in actions:
                self.toolBar.addAction(actions[i])
                i=i+1
            
    # todo: remove from extension toolBar
    
  
    
    
  def run( self):
    self.iface.mapCanvas().freeze(1)  
    layer = self.iface.activeLayer()
    try :
        if not layer: 
           QMessageBox.warning(None, QtGui.QApplication.translate("EasyCustomLabeling", "Easy custom labeling error:", None, QtGui.QApplication.UnicodeUTF8),QtGui.QApplication.translate("EasyCustomLabeling", "Please select a vector layer", None, QtGui.QApplication.UnicodeUTF8))
           return
        if not layer.type() == layer.VectorLayer:
           QMessageBox.warning(None, QtGui.QApplication.translate("EasyCustomLabeling", "Easy custom labeling error:", None, QtGui.QApplication.UnicodeUTF8),QtGui.QApplication.translate("EasyCustomLabeling", "Selected layer is not a vector layer", None, QtGui.QApplication.UnicodeUTF8))

           return

        # detect if selection exists on that layer
        #debug 
        nbSelectedObjects = layer.selectedFeatureCount()
        #QMessageBox.warning( None, "Easy custom labeling DEBUG: SELECTION", "nb objets : " +  str(nbSelectedObjects))   
        
        keepUserSelection = False
       
        if not nbSelectedObjects == 0 : 
           
            msgBox = QMessageBox()
            msgBox.setIcon(QtGui.QMessageBox.Question)
            msgBox.setWindowTitle ("EasyCustomLabeling")
            msgBox.setText(QtGui.QApplication.translate("EasyCustomLabeling", "Use selected object(s) only for labeling" , None, QtGui.QApplication.UnicodeUTF8)+ " ("+   str(nbSelectedObjects) + ")?")
            msgBox.setStandardButtons(QMessageBox.Yes | QMessageBox.No |QMessageBox.Cancel)
            msgBox.setDefaultButton(QMessageBox.Ok) # This function was introduced in Qt 4.3.
            ret = msgBox.exec_() #ret_val = 16384 si OK, 4194304 sinon
            #QMessageBox.warning( None, "DEBUG selection dialog", str(ret))
            if ret == 4194304 : # cancel  button finish program
                self.iface.mapCanvas().freeze(0)  
                return
            elif ret == 65536  :  # No button65536  selects all objects in layer 
                layer.select([])
                layer.setSelectedFeatures([obj.id() for obj in layer]) 
            elif ret == 16384 :
                keepUserSelection = True
                #QMessageBox.warning(None, "!", "sets keepUserSelection = True " )
        else : 
            layer.select([])
            layer.setSelectedFeatures([obj.id() for obj in layer])  
            
            
        nbSelectedObjects = layer.selectedFeatureCount()
        #QMessageBox.warning( None, "Easy custom labeling DEBUG: SELECTION after msgbox", "nb objets : " +  str(nbSelectedObjects))     
         
        
        if layer.selectedFeatureCount() > 500 :  #alert if many objects selected
      
            msgBox = QMessageBox()
            msgBox.setText(QtGui.QApplication.translate("EasyCustomLabeling","Your layer contains many objects. Continue anyway?", None, QtGui.QApplication.UnicodeUTF8))
            msgBox.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
            msgBox.setDefaultButton(QMessageBox.Ok) # This function was introduced in Qt 4.3.
            ret = msgBox.exec_() #ret_val = 1024 si OK, 4194304 sinon
            #QMessageBox.warning( None, "DEBUG", str(ret))
            if ret == 4194304 :
                self.iface.mapCanvas().freeze(0)  
                return
         
            
            
                 
        provider = layer.dataProvider()

        # allA = provider.attributeIndexes()
        # # TODO: use current selection (alert user and ask)
        # provider.select( allA)
        
        
        
        feat = QgsFeature()
            
        centro = QgsVectorLayer( "Point", "Label", "memory") # creates points  memory layer 
        centro.setLayerName("Label_"+layer.name()) 
        centro.setCrs(layer.crs())
        
        prCentro = centro.dataProvider() # create a layer of points populated with centroid of selected layer
        # duplicate fields into centro Layer
       
        #layer_fields = provider.fields() not working if oids /fids /geom not at the end of view/table   
        layer_fields = {} # looping fields with using incremented id (and not native id of fieldMap())
        idx = 0
       
        for k,v in provider.fields().iteritems():
            #QMessageBox.warning( None, "Easy custom labeling DEBUG: ",  str(v.name())  )  #DEBUG  name ()
            try:
                v = provider.fields()[k]
                
            except:
                v = None

            layer_fields[idx] = v
            idx = idx + 1    

       
        #QMessageBox.warning( None, "Easy custom labeling DEBUG: ",  str(len(layer_fields)  ))  #DEBUG  name ()    
       
              
        last_field_id = len(provider.fields())
                
        # add specific fields for data driven custom labeling
        #QMessageBox.warning(None, "!", QString(str(len( layer_fields))))
        layer_fields[last_field_id+1] = QgsField( "LblField", QVariant.String, "varchar", 255)
        layer_fields[last_field_id+2] = QgsField( "LblId", QVariant.Int, "integer", 1)    
        layer_fields[last_field_id+3] = QgsField( "LblX", QVariant.Double, "numeric", 10, 2)    
        layer_fields[last_field_id+4] = QgsField( "LblY", QVariant.Double, "numeric", 10, 2)      
        layer_fields[last_field_id+5] = QgsField( "LblAlignH", QVariant.String, "varchar", 12)      
        layer_fields[last_field_id+6] = QgsField( "LblAlignV", QVariant.String, "varchar", 12)      
        layer_fields[last_field_id+7] = QgsField( "LblSize", QVariant.Int, "integer", 1 )    
        layer_fields[last_field_id+8] = QgsField( "LblRot", QVariant.Double, "numeric", 10, 2)  
        layer_fields[last_field_id+9] = QgsField( "LblBold", QVariant.Int, "integer", 1)       
        layer_fields[last_field_id+10] = QgsField( "LblItalic", QVariant.Int, "integer", 1)      
        layer_fields[last_field_id+11] = QgsField( "LblColor", QVariant.String, "varchar", 7)  
        layer_fields[last_field_id+12] = QgsField( "LblFont", QVariant.String, "varchar", 64)       
        layer_fields[last_field_id+13] = QgsField( "LblUnder", QVariant.Int, "integer", 1)    
        layer_fields[last_field_id+14] = QgsField( "LblStrike", QVariant.Int, "integer", 1)
        
        
        #QMessageBox.warning( None, "Easy custom labeling DEBUG: layer_fields dictionnary",  str(layer_fields)  )  #DEBUG  name ()

        field_list=[]
        for k,v in layer_fields.iteritems():
        #QMessageBox.warning( None, "k v",  str(k) + "" + str(v) )
            f = QgsField(v)
        # recrer les champs de type int8
            if (f.typeName() == "int4"):
                v = QgsField( f.name(), QVariant.Int, f.typeName(), f.length(), f.precision())
            if (f.typeName() == "int8"):
                v = QgsField( f.name(), QVariant.Int, f.typeName(), f.length(), f.precision())

            field_list.append(v)
        
        ret = prCentro.addAttributes( field_list )  
        
      
        #last_field_id = 0
        #for k,v in attrs.iteritems():
        #    last_field_id = last_field_id+1
            
        # while provider.nextFeature(feat): # adds rows to Centro layer from selected layer 
       
        for feat in layer.selectedFeatures(): 
            fet = QgsFeature()
            geom = feat.geometry()
            zPoint = geom.centroid().asPoint()
            fet.setGeometry(QgsGeometry.fromPoint( zPoint)) # create geometry as centroid
            
            attrs = feat.attributeMap()
            #last_field_id = len(attrs)-1
            
            #fet.setAttributeMap(attrs) # this is not working if oid is present in table because it is masked for attributeMap and not setAttribute  > workaround by using a dictionnary with own indice
            #attrs = feat.attributeMap()

            idx = 0

            for k,v in attrs.iteritems():
                #QMessageBox.warning( None, "k v",  str(idx) + " "+str(k) )
                try:
                    v = attrs[k]
                except:
                    v = None
                fet.changeAttribute(idx, v)
                idx = idx + 1

            last_field_id = idx-1


            
            myfieldNameIndex = provider.fieldNameIndex(layer.displayField()) # get id of display field if filled, if not use first field. Fill labeField with display field or first field if displayfield not defined
            if myfieldNameIndex >= 0:
                fet.addAttribute( prCentro.fieldNameIndex("LblField"), fet.attributeMap()[myfieldNameIndex].toString()) 
            else:
                fet.addAttribute( prCentro.fieldNameIndex("LblField"), fet.attributeMap()[0].toString()) 
                
         
            #fet.addAttribute( last_field_id+2, QVariant( geom.centroid().asPoint().x())) # coord x
            #fet.addAttribute( last_field_id+3, QVariant( geom.centroid().asPoint().y())) # coord y 
            # fet.addAttribute( last_field_id+4, QVariant( "Left"))   # align H field
            #fet.addAttribute( last_field_id+5, QVariant( "Base"))   # align V field
            fet.addAttribute( prCentro.fieldNameIndex("LblSize"), QVariant())   # size field
            # fet.addAttribute( last_field_id+7, QVariant( 0 ) )   # rotation field
            # fet.addAttribute( last_field_id+8, QVariant( 0 ) )   # bold field
            # fet.addAttribute( last_field_id+9, QVariant( 0 ) )   # italic field
            # fet.addAttribute( last_field_id+10, QVariant( ""))   # color
            # fet.addAttribute( last_field_id+11, QVariant("Arial"))   # font family
            # fet.addAttribute( last_field_id+11, QVariant("0")) #underline
            
            prCentro.addFeatures( [ fet ] )
            centro.updateExtents()
          

        if not keepUserSelection :
            #QMessageBox.warning(None, "!", "removing selection")
            layer.removeSelection() 
            
        zCentroideLayer = QgsMapLayerRegistry.instance().addMapLayer(centro, True)  # adds centro to map registry

        # customize style
       
        zCentroideLayer.setUsingRendererV2(1)    
       
        #rendererV2 = zCentroideLayer.rendererV2()
        # creates default style for label (transparent point, default labeling ) 
        
       
        style_path = os.path.join( os.path.dirname(__file__), "label_style.qml" )
        (errorMsg, result) = zCentroideLayer.loadNamedStyle( style_path )

        # for s in rendererV2.symbols():
            # s.setAlpha(0)
            # s.setColor(QColor(168, 168, 168))
            
            # if isinstance(s, QgsMarkerSymbolV2):
                # s.setSize(1)
      
        
        
        # activate editing
        self.iface.setActiveLayer(zCentroideLayer )
        self.iface.actionToggleEditing().trigger()
        self.iface.actionToggleEditing().setEnabled(True) 
        self.editEnabled = True
        
        
        
        # parameters for advanced labeling -- picked up from a qgs model file 
        # attention, ces custom properties se basent sur le numro d'ordre du champ. ne fonctionne pas  la rouverture depuis qgis 1.8 qui dcale les champs avec un ajout de FID (GDAL.. ) 
        #zCentroideLayer.setCustomProperty("labeling/fieldName", last_field_id )  
        #QMessageBox.warning( None, "Easy custom labeling DEBUG: ",   str(prCentro.fieldNameIndex("LblField"))  )  #DEBUG 
        
        #generic labeling properties
        zCentroideLayer.setCustomProperty("labeling/fieldName", "LblField" )  # default value provider.fieldNameIndex(layer.displayField())
        zCentroideLayer.setCustomProperty("labeling","pal" ) # new gen labeling activated 
        zCentroideLayer.setCustomProperty("labeling/fontSize","8" ) # default value 
        zCentroideLayer.setCustomProperty("labeling/multiLineLabels","true" ) # default value 
        zCentroideLayer.setCustomProperty("labeling/enabled","true" ) # default value 
        
        #data defined properties 
        zCentroideLayer.setCustomProperty("labeling/dataDefinedProperty9", prCentro.fieldNameIndex("LblX"))  # data defined field for coordX
        zCentroideLayer.setCustomProperty("labeling/dataDefinedProperty10",prCentro.fieldNameIndex("LblY"))  # data defined field for CoordY
        zCentroideLayer.setCustomProperty("labeling/dataDefinedProperty11",prCentro.fieldNameIndex("LblAlignH") )  # data defined field for align H
        zCentroideLayer.setCustomProperty("labeling/dataDefinedProperty12",prCentro.fieldNameIndex("LblAlignV") )  # data defined field for align V
        zCentroideLayer.setCustomProperty("labeling/dataDefinedProperty0" ,prCentro.fieldNameIndex("LblSize") ) #  data defined field for Size
        zCentroideLayer.setCustomProperty("labeling/dataDefinedProperty14" ,prCentro.fieldNameIndex("LblRot") ) #  data defined field for Rotation
        zCentroideLayer.setCustomProperty("labeling/dataDefinedProperty1" ,prCentro.fieldNameIndex("LblBold") ) #  data defined field for Bold
        zCentroideLayer.setCustomProperty("labeling/dataDefinedProperty2" ,prCentro.fieldNameIndex("LblItalic")) #  data defined field for Italic
        zCentroideLayer.setCustomProperty("labeling/dataDefinedProperty3" ,prCentro.fieldNameIndex("LblUnder")) #  data defined field for Underline
        zCentroideLayer.setCustomProperty("labeling/dataDefinedProperty4" ,prCentro.fieldNameIndex("LblColor") ) #  data defined field for Color
        # font is not working properly with 1.8. > disabled 
		#zCentroideLayer.setCustomProperty("labeling/dataDefinedProperty6" ,prCentro.fieldNameIndex("LblFont") ) #  data defined field for Font family
        zCentroideLayer.setCustomProperty("labeling/dataDefinedProperty5" ,prCentro.fieldNameIndex("LblStrike") ) #  data defined field for Font family

        
        # hack to activate custom labeling buttons 
        self.iface.setActiveLayer(layer)
        self.iface.setActiveLayer(zCentroideLayer)

        #redraws registry and mapcanvas.
        layer.removeSelection() 
        if hasattr(zCentroideLayer, "setCacheImage" ): 
            zCentroideLayer.setCacheImage(None )
        
        zCentroideLayer.triggerRepaint()
        self.iface.legendInterface().refreshLayerSymbology( zCentroideLayer ) 
    
    except: 
        raise 
        
    finally :     
        
        QgsMapLayerRegistry.instance().clearAllLayerCaches () #clean cache to allow mask layer to appear on refresh
        self.iface.mapCanvas().freeze(0)  
        self.iface.mapCanvas().refresh()
        QMessageBox.warning( None, "Avertissement", 'Pensez a enregistrer les editions de votre couche d tiquettes avant de quitter')
    
  def runAbout(self):
    QMessageBox.about(None, QtGui.QApplication.translate("EasyCustomLabeling", "texte about", None, QtGui.QApplication.UnicodeUTF8), QtGui.QApplication.translate("EasyCustomLabeling", "<strong>Easy custom labeling v. 0.4,  Regis Haubourg (AEAG) - 2012. \n \n Action 1:This plugin duplicate a layer, transforming geometries into centroids, \n and adds all required fields for custom labeling. \n \n Action 2 - Arrow function draws lines between label and original object \n \n WARNING! This plugin requires to use Memory Layer Saver plugin if you want to save labels with project. \n In QGIS 1.8, memory layer saver 1.0 is needed because of new gml behaviour (GDAL 1.9) \n \n Please send bugs or features requests here : http://hub.qgis.org/projects/easycustomlabeling </strong>", None, QtGui.QApplication.UnicodeUTF8))
        
  
  def runArrow(self):     # action that draws lines between labels and original objects. Require a layer made with upper function. Draws a line only if a label as been moved 
    self.iface.mapCanvas().freeze(1)  
    sourcelayer = self.iface.activeLayer()
    
    try :
        if not sourcelayer:
           QMessageBox.warning(None, QtGui.QApplication.translate("EasyCustomLabeling", "Easy custom labeling error:", None, QtGui.QApplication.UnicodeUTF8),QtGui.QApplication.translate("EasyCustomLabeling", "No layer selected. Please select a centroid labeling layer", None, QtGui.QApplication.UnicodeUTF8))
           return
        if not sourcelayer.type() == sourcelayer.VectorLayer:
           QMessageBox.warning(None, QtGui.QApplication.translate("EasyCustomLabeling", "Easy custom labeling error:", None, QtGui.QApplication.UnicodeUTF8), QtGui.QApplication.translate("EasyCustomLabeling", "Selected layer is not a vector layer: Please select a centroid labeling layer", None, QtGui.QApplication.UnicodeUTF8))
           return
        
       
        sourceProvider = sourcelayer.dataProvider() # source layer provider
        
        
        
        
         # create feature for target layer
        
        Target = QgsVectorLayer("LineString", "Arrow_"+sourcelayer.name(), "memory" ) # cre la couche memory layer de ligne
        Targetprovider  = Target.dataProvider()  
       # sourcelayer_fields = sourceProvider.fields() #copy fields from source layer 
        sourcelayer_fields = {} # looping fields with using incremented id (and not native id of fieldMap())
        idx = 0
        labelFieldsOk = False
        
        for k,v in sourceProvider.fields().iteritems():
            #QMessageBox.warning( None, "Easy custom labeling DEBUG: ",  str(v.name())  )  #DEBUG  name ()
            if v.name().toUtf8()  == 'LblX':
                labelFieldsOk = True
            try:
                v = sourceProvider.fields()[k]
                
            except:
                v = None

            sourcelayer_fields[idx] = v
            idx = idx + 1    

        Targetlayer_fields = sourcelayer_fields
        
        fld_count = len( sourcelayer_fields ) 
       
        # tests if source layer is a compatible layer : fields LblX and LblY required
        
        # for k,v in Targetlayer_fields.iteritems():  
            # mytext =  mytext + "\n" + QString(str(k)) + " - " + str(v.name()) 
            # if str(v.name()) == 'LblX':
                # labelFieldsOk = True
        # QMessageBox.warning( None, "Easy custom labeling DEBUG lines: source fields ",   mytext) #DEBUG 
        # QMessageBox.warning( None, "debug", QtGui.QApplication.translate("EasyCustomLabeling", "ProviderArrow.fieldNameIndex(LblX) =" + str(sourceProvider.fieldNameIndex('LblX')) , None, QtGui.QApplication.UnicodeUTF8) )
        # # check if nfield  and nfield + 1  are named CoordX and CoordY  > means it is a centroid layer produced by run function 
        
        
        
        #converts dictionnary to list   
        field_list=[]
        mytext = str(fld_count) +"source Fields" +"\n" #DEBUG 
        for k,v in sourcelayer_fields.iteritems():
            f = QgsField(v)
            mytext =  mytext + "\n" + QString(str(k)) + " - " + v.name().toUtf8()  
            if v.name().toUtf8()  == 'LblX':
                labelFieldsOk = True
            # recrer les champs de type int8
            if (f.typeName() == "int8"):
                v = QgsField( f.name(), QVariant.Int, f.typeName(), f.length(), f.precision())
            if (f.typeName() == "int4"):
                v = QgsField( f.name(), QVariant.Int, f.typeName(), f.length(), f.precision())
            
            field_list.append(v)
           
        #QMessageBox.warning( None, "Easy custom labeling DEBUG lines: source fields ",   mytext) #DEBUG 
        # QMessageBox.warning( None, "debug", QtGui.QApplication.translate("EasyCustomLabeling", "ProviderArrow.fieldNameIndex(LblX) =" + str(sourceProvider.fieldNameIndex('LblX')) , None, QtGui.QApplication.UnicodeUTF8) )
            
        if not labelFieldsOk : 
            QMessageBox.warning( None, "Error", QtGui.QApplication.translate("EasyCustomLabeling", "Active layer must be compatible with a layer of centroids", None, QtGui.QApplication.UnicodeUTF8) )
            return    
            
        ret = Targetprovider.addAttributes( field_list ) #add all fields from target to source
        
       
        Target.updateFieldMap()
        
        mytext = str(fld_count) + "target Fields " +"\n" #DEBUG 
        
        # for k,v in Targetlayer_fields.iteritems():  
            # mytext =  mytext + "\n" + QString(str(k)) + " - " + str(v.name()) 
        #QMessageBox.warning( None, "Easy custom labeling DEBUG lines: target fields ",   mytext) #DEBUG 
        
        
         # array of field indexes
        #QMessageBox.warning( None, "Easy custom labeling DEBUG layer attribute indexes to fetch: ",   str(layerProvider.fields()) ) #DEBUG     
        #allA=layerProvider.attributeIndexes()
        #layerProvider.select(allA) # get selection of source layer attributes
        #DEBUG check what is featArrow
       
        LblXfieldID= sourceProvider.fieldNameIndex("LblX")
        LblYfieldID= sourceProvider.fieldNameIndex("LblY")
        #QMessageBox.warning( None, "Easy custom labeling DEBUG attr: find new lblx field by name;  ", 'x id: ' +  str(LblXfieldID) + ' y id:' + str(LblYfieldID))#DEBUG   
        # selection alternative
        sourcelayer.select([])
        sourcelayer.setSelectedFeatures([obj.id() for obj in sourcelayer])
        
        #SourceFeature = QgsFeature() 
       
         
        
       
        #while layerProvider.nextFeature( featArrow ): # loop on features in source target 
        LabelMoved = False
        
        for SourceFeature in sourcelayer.selectedFeatures():
            
            Targetfeature = QgsFeature() # creates feature of destination target
            
            geom = SourceFeature.geometry() #  gets source geometry into geom
            geom_x = QVariant(geom.centroid().asPoint().x()).toString() 
            geom_y = QVariant(geom.centroid().asPoint().y()).toString()
            
            #QMessageBox.warning( None, "Easy custom labeling DEBUG attr: isvalid ( featarrow) ; should be true ",   str(SourceFeature.isValid () ) ) #DEBUG   
            #QMessageBox.warning( None, "Easy custom labeling DEBUG :  display attributeMap of source feature",  str(SourceFeature.attributeMap())) #DEBUG      # attributemap not working. fields are omitted..
           
            # debug
            
            #QMessageBox.warning( None, "Easy custom labeling DEBUG geoms objects ",   geom_x + '   ' + geom_y ) #DEBUG   
            
            sourceAttrs = SourceFeature.attributeMap() # gets source list of attributes
            

            #QMessageBox.warning( None, "Easy custom labeling DEBUG :  display attributeMap of source feature after clearattributemap",  str(SourceFeature.attributeMap())) #DEBUG      # attributemap not working. fields are omitted..
            # QMessageBox.warning( None, "Easy custom labeling DEBUG :  display attributeMap of target feature after clearattributemap",  str(Targetfeature.attributeMap())) #DEBUG      # attributemap not working. fields are omitted..
            
            try :
                label_geom_x = sourceAttrs[LblXfieldID].toString()
                label_geom_y = sourceAttrs[LblYfieldID].toString()
            except: 
                label_geom_x = ''
                label_geom_y = ''
                
            #myrow = 'geom_x: '+ geom_x + '; geom_y: ' + geom_y + '\n \n attribumap(SourceFeature): \n' 
            # QMessageBox.warning( None, "Easy custom labeling DEBUG xy labels ",   label_geom_x + '   ' + label_geom_y ) #DEBUG   
        
            
            #cre une gom linaire avec les champs X y, uniquement si x<> x old, Y <> y old
            
            if not label_geom_x == '' : 
                
                LabelMoved = True           
                theLineWKT = 'LINESTRING('+ label_geom_x+' '+  label_geom_y + ' , '+ geom_x+ ' ' +geom_y+ ')' 
                #theLineWKT = 'LINESTRING(200 200 , 0 0)'
                #QMessageBox.warning( None, "Easy custom labeling DEBUG LINE ",  theLineWKT ) #DEBUG   
                Targetfeature.setGeometry( QgsGeometry.fromWkt( theLineWKT ) )
                  
                Targetfeature.setAttributeMap(sourceAttrs)
                               
                Targetprovider.addFeatures( [ Targetfeature ] )
                
        sourcelayer.removeSelection()         
        
        if  LabelMoved == False :
            QMessageBox.warning( None, "Error", QtGui.QApplication.translate("EasyCustomLabeling", "No Label Have been moved. No layer will be created", None, QtGui.QApplication.UnicodeUTF8) )
            return
            
        
        Target.updateExtents()
            
        zArrowLayer = QgsMapLayerRegistry.instance().addMapLayer( Target )
        zArrowLayer.setUsingRendererV2(1)   
        #zArrowZrendererV2 = zArrowLayer.rendererV2()
        # creates default line for label (black center line, outline white, arrow at the end, transparency 
       
        style_path = os.path.join( os.path.dirname(__file__), "arrow_style.qml" )
        (errorMsg, result) = zArrowLayer.loadNamedStyle( style_path )

      
        
        # for s in zArrowZrendererV2.symbols():
            # s.setAlpha(0.31)
            # s.setColor(QColor(0, 0, 0))
            
            # if isinstance(s, QgsLineSymbolV2):
                # s.setWidth(0.5)
       
        self.iface.legendInterface().refreshLayerSymbology( zArrowLayer ) 
        
        zArrowLayer.triggerRepaint()
        
    except: 
        raise 
        
    finally :     
        self.iface.mapCanvas().freeze(0)  
        self.iface.mapCanvas().refresh()